diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
index 277320a62..014894a41 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
@@ -1,6 +1,9 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.ISupportable;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.util.helper.Side;
@@ -11,7 +14,7 @@ import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class BlockLogicTorch extends BlockLogic
+public class BlockLogicTorch extends BlockLogic implements ISupportable
 {
     public static final int MASK_DIRECTION = 0b0000_0111;
     public static final int SIDE_NONE = 0;
@@ -66,79 +69,20 @@ public class BlockLogicTorch extends BlockLogic
         return false;
     }
 
-    private boolean canPlaceOnTop(World world, int x, int y, int z)
-    {
-        int blockBelow = world.getBlockId(x, y, z);
-        return world.canPlaceOnSurfaceOfBlock(x, y, z)
-            || blockBelow == Blocks.FENCE_PLANKS_OAK.id()
-            || blockBelow == Blocks.FENCE_PLANKS_OAK_PAINTED.id()
-            || blockBelow == Blocks.FENCE_CHAINLINK.id()
-            || blockBelow == Blocks.FENCE_PAPER_WALL.id()
-            || blockBelow == Blocks.FENCE_STEEL.id();
-    }
-
     @Override
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
-        if(world.isBlockNormalCube(x - 1, y, z))
-        {
-            return true;
-        }
-        if(world.isBlockNormalCube(x + 1, y, z))
-        {
-            return true;
-        }
-        if(world.isBlockNormalCube(x, y, z - 1))
-        {
-            return true;
-        }
-        if(world.isBlockNormalCube(x, y, z + 1))
-        {
-            return true;
-        }
-        return canPlaceOnTop(world, x, y - 1, z);
+        return isSupported(world, x, y, z, Side.BOTTOM)
+            || isSupported(world, x, y, z, Side.NORTH)
+            || isSupported(world, x, y, z, Side.SOUTH)
+            || isSupported(world, x, y, z, Side.WEST)
+            || isSupported(world, x, y, z, Side.EAST);
     }
 
     @Override
     public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
-        int orientation = SIDE_NONE;
-        switch (side) {
-            case TOP:
-                if(canPlaceOnTop(world, x, y - 1, z))
-                {
-                    orientation = SIDE_BOTTOM;
-                }
-                break;
-            case NORTH:
-                if(world.isBlockNormalCube(x, y, z + 1))
-                {
-                    orientation = SIDE_SOUTH;
-                }
-                break;
-            case SOUTH:
-                if(world.isBlockNormalCube(x, y, z - 1))
-                {
-                    orientation = SIDE_NORTH;
-                }
-                break;
-            case WEST:
-                if(world.isBlockNormalCube(x + 1, y, z))
-                {
-                    orientation = SIDE_EAST;
-                }
-                break;
-            case EAST:
-                if(world.isBlockNormalCube(x - 1, y, z))
-                {
-                    orientation = SIDE_WEST;
-                }
-                break;
-        }
-        if (orientation == SIDE_NONE) {
-            orientation = getDefaultOrientation(world, x, y, z);
-        }
-        world.setBlockMetadataWithNotify(x, y, z, orientation);
-        dropTorchIfCantStay(world, x, y, z);
+        if (side.isHorizontal()) side = side.getOpposite();
+        onBlockPlacedOnSide(world, x, y, z, side, xPlaced, yPlaced);
     }
 
     @Override
@@ -147,32 +91,27 @@ public class BlockLogicTorch extends BlockLogic
         if (side.isHorizontal()) side = side.getOpposite();
         switch (side) {
             case TOP:
-                if(canPlaceOnTop(world, x, y - 1, z))
-                {
+                if(isSupported(world, x, y, z, Side.BOTTOM)) {
                     orientation = SIDE_BOTTOM;
                 }
                 break;
             case NORTH:
-                if(world.isBlockNormalCube(x, y, z + 1))
-                {
+                if(isSupported(world, x, y, z, Side.SOUTH)) {
                     orientation = SIDE_SOUTH;
                 }
                 break;
             case SOUTH:
-                if(world.isBlockNormalCube(x, y, z - 1))
-                {
+                if(isSupported(world, x, y, z, Side.NORTH)) {
                     orientation = SIDE_NORTH;
                 }
                 break;
             case WEST:
-                if(world.isBlockNormalCube(x + 1, y, z))
-                {
+                if(isSupported(world, x, y, z, Side.EAST)) {
                     orientation = SIDE_EAST;
                 }
                 break;
             case EAST:
-                if(world.isBlockNormalCube(x - 1, y, z))
-                {
+                if(isSupported(world, x, y, z, Side.WEST)) {
                     orientation = SIDE_WEST;
                 }
                 break;
@@ -185,32 +124,24 @@ public class BlockLogicTorch extends BlockLogic
     }
 
     public int getDefaultOrientation(World world, int x, int y, int z) {
-        if (canPlaceOnTop(world, x, y - 1, z)) {
+        if(isSupported(world, x, y, z, Side.BOTTOM)) {
             return SIDE_BOTTOM;
-        }
-        if(world.isBlockNormalCube(x, y, z + 1))
-        {
-            return SIDE_SOUTH;
-        }
-        if(world.isBlockNormalCube(x, y, z - 1))
-        {
-            return SIDE_NORTH;
-        }
-        if(world.isBlockNormalCube(x + 1, y, z))
-        {
-            return SIDE_EAST;
-        }
-        if(world.isBlockNormalCube(x - 1, y, z))
-        {
+        } else if(isSupported(world, x, y, z, Side.WEST)) {
             return SIDE_WEST;
+        } else if(isSupported(world, x, y, z, Side.EAST)) {
+            return SIDE_EAST;
+        } else if(isSupported(world, x, y, z, Side.NORTH)) {
+            return SIDE_NORTH;
+        } else if(isSupported(world, x, y, z, Side.SOUTH)) {
+            return SIDE_SOUTH;
         }
         return SIDE_NONE;
     }
     
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
-        super.updateTick(world, x, y, z, rand);
+        super.updateTick(world, x, y, z, rand, isRandomTick);
         if(world.getBlockMetadata(x, y, z) == SIDE_NONE)
         {
             onBlockPlacedByWorld(world, x, y, z);
@@ -220,25 +151,9 @@ public class BlockLogicTorch extends BlockLogic
     @Override
 	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
-        if(world.isBlockNormalCube(x - 1, y, z))
-        {
-            world.setBlockMetadataWithNotify(x, y, z, SIDE_WEST);
-        } else
-        if(world.isBlockNormalCube(x + 1, y, z))
-        {
-            world.setBlockMetadataWithNotify(x, y, z, SIDE_EAST);
-        } else
-        if(world.isBlockNormalCube(x, y, z - 1))
-        {
-            world.setBlockMetadataWithNotify(x, y, z, SIDE_NORTH);
-        } else
-        if(world.isBlockNormalCube(x, y, z + 1))
-        {
-            world.setBlockMetadataWithNotify(x, y, z, SIDE_SOUTH);
-        } else
-        if(canPlaceOnTop(world, x, y - 1, z))
-        {
-            world.setBlockMetadataWithNotify(x, y, z, SIDE_BOTTOM);
+        int orientation = getDefaultOrientation(world, x, y, z);
+        if (orientation != SIDE_NONE) {
+            world.setBlockMetadataWithNotify(x, y, z, orientation);
         }
         dropTorchIfCantStay(world, x, y, z);
     }
@@ -250,25 +165,19 @@ public class BlockLogicTorch extends BlockLogic
         int side = world.getBlockMetadata(x, y, z) & MASK_DIRECTION;
         switch (side) {
             case SIDE_WEST:
-                invalid = !world.isBlockNormalCube(x - 1, y, z);
+                invalid = !isSupported(world, x, y, z, Side.WEST);
                 break;
             case SIDE_EAST:
-                invalid = !world.isBlockNormalCube(x + 1, y, z);
+                invalid = !isSupported(world, x, y, z, Side.EAST);
                 break;
             case SIDE_NORTH:
-                invalid = !world.isBlockNormalCube(x, y, z - 1);
+                invalid = !isSupported(world, x, y, z, Side.NORTH);
                 break;
             case SIDE_SOUTH:
-                invalid = !world.isBlockNormalCube(x, y, z + 1);
+                invalid = !isSupported(world, x, y, z, Side.SOUTH);
                 break;
             case SIDE_BOTTOM:
-                int blockBelow = world.getBlockId(x, y - 1, z);
-                invalid = !(world.canPlaceOnSurfaceOfBlock(x, y - 1, z)
-                    || blockBelow == Blocks.FENCE_PLANKS_OAK.id()
-                    || blockBelow == Blocks.FENCE_PLANKS_OAK_PAINTED.id()
-                    || blockBelow == Blocks.FENCE_CHAINLINK.id()
-                    || blockBelow == Blocks.FENCE_PAPER_WALL.id()
-                    || blockBelow == Blocks.FENCE_STEEL.id());
+                invalid = !isSupported(world, x, y, z, Side.BOTTOM);
                 break;
             default:
                 invalid = true;
@@ -280,16 +189,11 @@ public class BlockLogicTorch extends BlockLogic
         }
     }
 
-    private boolean dropTorchIfCantStay(World world, int x, int y, int z)
+    private void dropTorchIfCantStay(World world, int x, int y, int z)
     {
-        if(!canPlaceBlockAt(world, x, y, z))
-        {
+        if(!canPlaceBlockAt(world, x, y, z)) {
             dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
             world.setBlockWithNotify(x, y, z, 0);
-            return false;
-        } else
-        {
-            return true;
         }
     }
 
@@ -330,4 +234,22 @@ public class BlockLogicTorch extends BlockLogic
     public int getLightmapCoord(WorldSource blockAccess, int x, int y, int z) {
 		return blockAccess.getLightmapCoord(x, y, z, block.emission > 0 ? 15 : 0);
     }
+
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
+    @Override
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        switch (side) {
+            case NORTH:
+            case SOUTH:
+            case WEST:
+            case EAST:
+            case BOTTOM:
+                return PartialSupport.INSTANCE.center();
+        }
+        return PartialSupport.INSTANCE;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
index 19e7dd9b4..008e95d36 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
@@ -90,7 +90,7 @@ public class BlockLogicTorchRedstone extends BlockLogicTorch {
     }
 
     @Override
-    public void updateTick(World world, int x, int y, int z, Random rand) {
+    public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick) {
         boolean isPowered = hasNeighborSignal(world, x, y, z);
         if (torchActive) {
             if (isPowered) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
index 834428ec4..f5900962c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
@@ -2,6 +2,9 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.FullSupport;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.PlacementMode;
 import net.minecraft.core.item.Item;
@@ -55,6 +58,31 @@ public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        int meta = world.getBlockMetadata(x, y, z);
+
+        if (isTrapdoorOpen(meta)) {
+            switch (meta & MASK_DIRECTION) {
+                case DIRECTION_SOUTH:  // South
+                    return side == Side.SOUTH ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
+                case DIRECTION_NORTH:  // North
+                    return side == Side.NORTH ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
+                case DIRECTION_EAST:  // East
+                    return side == Side.EAST ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
+                case DIRECTION_WEST:  // West
+                default:
+                    return side == Side.WEST ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
+            }
+        } else {
+            if (isUpperHalf(meta)) {
+                return side == Side.TOP ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
+            } else {
+                return side == Side.BOTTOM ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
+            }
+        }
+    }
+
     @Override
     public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z) {
         int meta = world.getBlockMetadata(x, y, z);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java
index a88ced793..841e1d3fb 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java
@@ -2,6 +2,9 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.ISupportable;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.current.util.BlockPos;
 import net.minecraft.core.current.util.BlockState;
 import net.minecraft.core.enums.EnumDropCause;
@@ -13,13 +16,14 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.chunk.ChunkPosition;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.ArrayList;
 import java.util.HashSet;
 import java.util.Random;
 import java.util.Set;
 
-public class BlockLogicWireRedstone extends BlockLogic {
+public class BlockLogicWireRedstone extends BlockLogic implements ISupportable {
     public static final int SIGNAL_MIN = 0;
     public static final int SIGNAL_MAX = 15;
     public static final int SIGNAL_STEP = 1;
@@ -49,9 +53,14 @@ public class BlockLogicWireRedstone extends BlockLogic {
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     @Override
     public boolean canPlaceBlockAt(World world, int x, int y, int z) {
-        return world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
+        return isSupported(world, x, y, z, Side.BOTTOM);
     }
 
     private void updatePowerStrength(World world, int x, int y, int z) {
@@ -402,4 +411,9 @@ public class BlockLogicWireRedstone extends BlockLogic {
         int blockId = worldSource.getBlockId(x, y, z);
         return blockId == Blocks.WIRE_REDSTONE.id();
     }
+
+    @Override
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return side == Side.BOTTOM ? PartialSupport.INSTANCE.center() : PartialSupport.INSTANCE;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index 09d260d1b..42dea22a9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -9,6 +9,7 @@ import net.minecraft.core.block.piston.BlockLogicPistonHead;
 import net.minecraft.core.block.piston.BlockLogicPistonMoving;
 import net.minecraft.core.block.piston.BlockLogicPistonBaseSteel;
 import net.minecraft.core.block.piston.BlockLogicPistonBaseSticky;
+import net.minecraft.core.block.support.ISupportable;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.entity.Entity;
@@ -726,7 +727,7 @@ public final class Blocks {
         .withSound(BlockSounds.STONE).withHardness(3F).withBlastResistance(10F).withOverrideColor(MaterialColor.coal)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
-    public static final Block<?> WIRE_REDSTONE = register("wire.redstone", "minecraft:block/wire_redstone", 450, BlockLogicWireRedstone::new)
+    public static final Block<BlockLogicWireRedstone> WIRE_REDSTONE = register("wire.redstone", "minecraft:block/wire_redstone", 450, BlockLogicWireRedstone::new)
         .withSound(BlockSounds.STONE).withHardness(0.0F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.redstone).setStatParent(() -> Items.DUST_REDSTONE)
         .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.PREVENT_MOB_SPAWNS);
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
index d1230c773..3be3df204 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
@@ -5,6 +5,9 @@ import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.support.FullSupport;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
@@ -28,6 +31,51 @@ public class BlockLogicPistonBase extends BlockLogic
     public static final int EVENT_EXTEND = 0;
     public static final int EVENT_RETRACT = 1;
 
+    public static final ISupport[] pistonSupportLookupTable = {
+        // Bottom
+        PartialSupport.INSTANCE,
+        FullSupport.INSTANCE,
+        PartialSupport.INSTANCE.center().up(),
+        PartialSupport.INSTANCE.center().down(),
+        PartialSupport.INSTANCE.center().right(),
+        PartialSupport.INSTANCE.center().left(),
+        // Top
+        FullSupport.INSTANCE,
+        PartialSupport.INSTANCE,
+        PartialSupport.INSTANCE.center().down(),
+        PartialSupport.INSTANCE.center().up(),
+        PartialSupport.INSTANCE.center().right(),
+        PartialSupport.INSTANCE.center().left(),
+        // North
+        PartialSupport.INSTANCE.center().up(),
+        PartialSupport.INSTANCE.center().down(),
+        PartialSupport.INSTANCE,
+        FullSupport.INSTANCE,
+        PartialSupport.INSTANCE.center().right(),
+        PartialSupport.INSTANCE.center().left(),
+        // South
+        PartialSupport.INSTANCE.center().up(),
+        PartialSupport.INSTANCE.center().down(),
+        FullSupport.INSTANCE,
+        PartialSupport.INSTANCE,
+        PartialSupport.INSTANCE.center().right(),
+        PartialSupport.INSTANCE.center().left(),
+        // West
+        PartialSupport.INSTANCE.center().up(),
+        PartialSupport.INSTANCE.center().down(),
+        PartialSupport.INSTANCE.center().left(),
+        PartialSupport.INSTANCE.center().right(),
+        PartialSupport.INSTANCE,
+        FullSupport.INSTANCE,
+        // East
+        PartialSupport.INSTANCE.center().up(),
+        PartialSupport.INSTANCE.center().down(),
+        PartialSupport.INSTANCE.center().left(),
+        PartialSupport.INSTANCE.center().right(),
+        FullSupport.INSTANCE,
+        PartialSupport.INSTANCE,
+    };
+
     private final int maxPushedBlocks;
 
     public BlockLogicPistonBase(Block<?> block, int maxPushedBlocks)
@@ -214,6 +262,14 @@ public class BlockLogicPistonBase extends BlockLogic
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        int meta = world.getBlockMetadata(x, y, z);
+        if ((meta & MASK_POWERED) == 0) return FullSupport.INSTANCE;
+        Direction dir = getDirection(meta);
+        return pistonSupportLookupTable[side.getId() * 6 + dir.getId()];
+    }
+
     public static Direction getDirection(int data)
     {
         return Direction.getDirectionById(data & MASK_DIRECTION);
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
index 243c3c75d..af08e52fc 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
@@ -7,6 +7,9 @@ import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.support.FullSupport;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
@@ -14,6 +17,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicPistonHead extends BlockLogic
 {
@@ -69,6 +73,12 @@ public class BlockLogicPistonHead extends BlockLogic
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        int meta = world.getBlockMetadata(x, y, z);
+        return getDirectionFromMeta(meta).getSide() == side ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
+    }
+
     @Override
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/block/support/FullSupport.java b/game/core/src/main/java/net/minecraft/core/block/support/FullSupport.java
index 9a822344c..d72fe000b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/support/FullSupport.java
+++ b/game/core/src/main/java/net/minecraft/core/block/support/FullSupport.java
@@ -1,14 +1,20 @@
 package net.minecraft.core.block.support;
 
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
 
 public class FullSupport implements ISupport {
-    public static final FullSupport INSTANCE = new FullSupport();
+    public static final @NotNull FullSupport INSTANCE = new FullSupport();
 
     private FullSupport() { }
 
     @Override
-    public boolean canSupport(final ISupport other, final Side side) {
+    public boolean canSupport(final @NotNull ISupport other, final @NotNull Side side) {
         return true;
     }
+
+    @Override
+    public String toString() {
+        return "{Full-support}";
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/support/ISupport.java b/game/core/src/main/java/net/minecraft/core/block/support/ISupport.java
index 30819f84d..bb66a7e73 100644
--- a/game/core/src/main/java/net/minecraft/core/block/support/ISupport.java
+++ b/game/core/src/main/java/net/minecraft/core/block/support/ISupport.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block.support;
 
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
 
 /**
  * Used to indicate how one block can support another "hangable" block.
@@ -11,5 +12,5 @@ public interface ISupport {
      * @param other The block to check against.
      * @return Whether the block keyed by "other" can be hung.
      */
-    boolean canSupport(final ISupport other, final Side side);
+    boolean canSupport(final @NotNull ISupport other, final @NotNull Side side);
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/support/ISupportable.java b/game/core/src/main/java/net/minecraft/core/block/support/ISupportable.java
index f7fcb3828..5bb6c81dc 100644
--- a/game/core/src/main/java/net/minecraft/core/block/support/ISupportable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/support/ISupportable.java
@@ -3,17 +3,18 @@ package net.minecraft.core.block.support;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 public interface ISupportable {
-    ISupport getSupportConstraint(final World world, final int x, final int y, final int z, final Side side);
+    @NotNull ISupport getSupportConstraint(final @NotNull World world, final int x, final int y, final int z, final @NotNull Side side);
 
-    default boolean isSupported(final World world, final int x, final int y, final int z, final Side side) {
-        final Block<?> supportingBlock = world.getBlock(x, y, z);
+    default boolean isSupported(final @NotNull World world, final int x, final int y, final int z, final @NotNull Side side) {
+        final Block<?> supportingBlock = world.getBlock(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ());
         if (supportingBlock == null) {
             return false;
         }
-        final ISupport supporting = supportingBlock.getSupport(world, x, y, z, side.getOpposite());
-        final ISupport supported = getSupportConstraint(world, x, y, z, side);
+        final ISupport supporting = supportingBlock.getSupport(world, x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), side.getOpposite());
+        final ISupport supported = this.getSupportConstraint(world, x, y, z, side);
         return supporting.canSupport(supported, side.getOpposite());
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/support/PartialSupport.java b/game/core/src/main/java/net/minecraft/core/block/support/PartialSupport.java
index f188faaa1..4708493ce 100644
--- a/game/core/src/main/java/net/minecraft/core/block/support/PartialSupport.java
+++ b/game/core/src/main/java/net/minecraft/core/block/support/PartialSupport.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block.support;
 
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
 
 public class PartialSupport implements ISupport {
     private static final byte UP = 0b00001;
@@ -9,8 +10,8 @@ public class PartialSupport implements ISupport {
     private static final byte RIGHT = 0b01000;
     private static final byte CENTER = 0b10000;
 
-    public static final PartialSupport INSTANCE;
-    private static final PartialSupport[] PERMUTATIONS = new PartialSupport[32];
+    public static final @NotNull PartialSupport INSTANCE;
+    private static final @NotNull PartialSupport @NotNull [] PERMUTATIONS = new PartialSupport[32];
 
     static {
         for (int i = 0; i < 32; i++) {
@@ -25,28 +26,28 @@ public class PartialSupport implements ISupport {
         this.supportField = supportField;
     }
 
-    public PartialSupport up() {
+    public @NotNull PartialSupport up() {
         return PERMUTATIONS[this.supportField | UP];
     }
 
-    public PartialSupport down() {
+    public @NotNull PartialSupport down() {
         return PERMUTATIONS[this.supportField | DOWN];
     }
 
-    public PartialSupport left() {
+    public @NotNull PartialSupport left() {
         return PERMUTATIONS[this.supportField | LEFT];
     }
 
-    public PartialSupport right() {
+    public @NotNull PartialSupport right() {
         return PERMUTATIONS[this.supportField | RIGHT];
     }
 
-    public PartialSupport center() {
+    public @NotNull PartialSupport center() {
         return PERMUTATIONS[this.supportField | CENTER];
     }
 
     @Override
-    public boolean canSupport(final ISupport other, final Side side) {
+    public boolean canSupport(final @NotNull ISupport other, final @NotNull Side side) {
         if (other instanceof PartialSupport) {
             byte supportField = this.supportField;
             // Check if flip
@@ -61,10 +62,22 @@ public class PartialSupport implements ISupport {
                     supportField |= LEFT;
                 }
             }
-            PartialSupport partialOther = (PartialSupport) other;
+            final @NotNull PartialSupport partialOther = (PartialSupport) other;
             return (supportField & partialOther.supportField) == partialOther.supportField;
         } else {
             return false;
         }
     }
+
+    @Override
+    public String toString() {
+        StringBuilder builder = new StringBuilder("{ Partial Support");
+        if ((this.supportField & UP) != 0) builder.append(", UP");
+        if ((this.supportField & DOWN) != 0) builder.append(", DOWN");
+        if ((this.supportField & LEFT) != 0) builder.append(", LEFT");
+        if ((this.supportField & RIGHT) != 0) builder.append(", RIGHT");
+        if ((this.supportField & CENTER) != 0) builder.append(", CENTER");
+        builder.append(" }");
+        return builder.toString();
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java b/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java
index 0c41ed3f4..fca80d65f 100644
--- a/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java
+++ b/game/core/src/main/java/net/minecraft/core/current/util/BlockState.java
@@ -5,6 +5,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 public class BlockState {
@@ -87,8 +88,12 @@ public class BlockState {
 
 	public boolean canSurvive(World world, BlockPos pos) {
 		Block<?> block = world.getBlock(pos.x, pos.y, pos.z);
-		Block<?> underBlock = world.getBlock(pos.x, pos.y - 1, pos.z);
-		return (block == null || block == Blocks.WIRE_REDSTONE || block.getMaterial().isReplaceable()) && underBlock != null && underBlock.isCubeShaped();
+		if (block == Blocks.WIRE_REDSTONE) {
+            return Blocks.WIRE_REDSTONE.getLogic().isSupported(world, pos.x, pos.y, pos.z, Side.BOTTOM);
+		} else {
+			Block<?> underBlock = world.getBlock(pos.x, pos.y - 1, pos.z);
+			return (block == null || block.getMaterial().isReplaceable()) && underBlock != null && underBlock.isCubeShaped();
+		}
 	}
 
 	public void dropItems(World world, BlockPos pos) {
